<script>
    export /**
     * @type {any}
     */
    let test_case;

    export /**
     * @type {any}
     */
    let test_mock_data = test_case.mock_data;

    test_mock_data = test_mock_data instanceof Array ? test_mock_data : [test_mock_data];

    let isHidden = true;

    function tryStringifyJson(obj) {
        try {
            return JSON.stringify(obj);
        } catch (error) {
            return obj;
        }
    }
</script>

<div class="testcase">
    <h2><b>Test Case: </b>{test_case.test_name}</h2>
    <p><b>Desc:</b> {test_case.description}</p>
    <div>
        <button type="button" class:active={isHidden} on:click={() => (isHidden = !isHidden)}>
            {#if isHidden}
                <span class="icon">&plus;</span>
            {:else}
                <span class="icon">&minus;</span>
            {/if}
            <em
                ><b
                    >This test contains {test_case.mock_data.length
                        ? test_case.mock_data.length
                        : 1} elements.</b
                > (click to expand)</em
            >
        </button>
        <div class={'content'} class:hidden={isHidden}>
            {#each test_mock_data as mock, index}
                <b>Test vector {index}:</b>
                <div class="collapsible bg-inherit">
                    <p><span>{tryStringifyJson(mock)}</span></p>
                </div>
            {/each}
        </div>
    </div>
</div>

<style>
    h2 {
        font-size: 1.5em;
    }
    .testcase {
        background-color: LightGray;
        padding-left: 1em;
        padding-top: 0.5em;
        padding-bottom: 0.5em;
        margin-top: 1em;
        margin-bottom: 1em;
    }
    .collapsible {
        background-color: #f7f7f7;
        color: #444;
        cursor: pointer;
        padding: 10px;
        width: 100%;
        border: none;
        text-align: left;
        outline: none;
        font-size: 15px;
    }

    /* Style the collapsible content. Note: hidden by default */
    .content {
        padding: 0 18px;
        transition: max-height 0.2s ease-out;
    }
</style>
